# Dynamically Generated
@builtin "number.ne"
@builtin "string.ne"
@builtin "whitespace.ne"
@{%
    function compact(v) {
        if (Array.isArray(v)) {
            return v.reduce((a, v) => (v === null || v === undefined || (v && v.length === 0) ) ? a : (a.push(v), a), []);
        } else {
            return v;
        }
    }

    function flatten(v) {
        let r;
        if (Array.isArray(v)) {
            r = v.reduce((a,v) => (a.push(...((v && Array.isArray(v)) ? flatten(v) : [v])), a), []);
        } else {
            r = v;
        }
        r = compact(r);
        return r;
        }
%}


rule -> rule0 rule1 rule2 rule3 rule4 rule5 rule6 rule7 rule8 rule9 rule10 rule11 rule12 rule13 rule14 
{% ([ rule0,rule1,rule2,rule3,rule4,rule5,rule6,rule7,rule8,rule9,rule10,rule11,rule12,rule13,rule14 ]) => {
    return {
        $class: "org.accordproject.ippayment.TemplateModel",
        
        royaltyText : rule1,
        royaltyRate : rule3,
        sublicensingRoyaltyText : rule5,
        sublicensingRoyaltyRate : rule7,
        paymentPeriod : rule9,
        paymentPeriodWithPermission : rule11
    };
}
%}

ROOT -> rule0 
{% ([ rule0 ]) => {
    return {
        
        
    };
}
%}



rule0 -> "Payments.\n\n1.  Royalty. On or before the last business day of each Quarterly Period during the Term and any Sell-off Period, Licensee shall pay to Licensor a royalty of " 


rule1 -> String {% id %} # royaltyText 


rule2 -> " percent (" 


rule3 -> Double {% id %} # royaltyRate 


rule4 -> "%) of the Net Sales Price for the respective preceding Quarterly Period.\n\n2. Sublicensing Revenue. On or before the last business day of each Quarterly Period during the Term and any Sell-off Period, Licensee shall pay to Licensor " 


rule5 -> String {% id %} # sublicensingRoyaltyText 


rule6 -> " percent (" 


rule7 -> Double {% id %} # sublicensingRoyaltyRate 


rule8 -> "%) of any royalties and fees received by Licensee from sublicensing any rights granted to it under this Agreement during the respective preceding Quarterly Period.\n\n3. Taxes. If Licensee is required by applicable Law to withhold taxes in connection with any sums payable to Licensor under this Agreement, Licensee may deduct the amount of the withholding from the payment it otherwise would have made to Licensor under this Agreement.\n\n4. Manner of Payment.\n\n(a) Royalties and any other sums payable under this Section shall be paid within " 


rule9 -> Duration {% id %} # paymentPeriod 


rule10 -> " following the end of each Quarterly Period in US dollars.\n\n(b) If Licensee is prohibited by a governmental authority in any country from making any payment due under this Section, then within the prescribed period for making the payment Licensee shall request permission from the governmental authority to make the payment and shall make the payment within " 


rule11 -> Duration {% id %} # paymentPeriodWithPermission 


rule12 -> " business days after receiving permission. If such permission is not received within " 


rule13 -> Duration {% id %} # paymentPeriodWithPermission 


rule14 -> " business days after Licensee's request, then Licensee, at Licensor's option, shall either deposit the payment in the currency of the relevant country in a bank account within that country designated by Licensor or make the payment to an associated company of Licensor designated by Licensor and having an office in the relevant country or in another country designated by Licensor.\n\n5. Royalty Statements. At the same time as payments are made under Section 4., Licensee shall submit a statement showing the total Net Sales Price of Licensed Product[s] received by Licensee and its Affiliates and sublicensees and the total amount of any sublicense royalties and other fees received by Licensee in the relevant Quarterly Period.\n\n" 


ContractState -> String  __  String 

{% ( data ) => {
    return {
        $class: "org.accordproject.common.ContractState",
        stateId : data[0],
        contract : data[2]
    };
}
%}


ContractModel -> String 

{% ( data ) => {
    return {
        $class: "org.accordproject.common.ContractModel",
        contractId : data[0]
    };
}
%}


ClauseModel -> String 

{% ( data ) => {
    return {
        $class: "org.accordproject.common.ClauseModel",
        clauseId : data[0]
    };
}
%}


Request -> String  __  DateTime 

{% ( data ) => {
    return {
        $class: "org.accordproject.common.Request",
        transactionId : data[0],
        timestamp : data[2]
    };
}
%}


Response -> String  __  DateTime 

{% ( data ) => {
    return {
        $class: "org.accordproject.common.Response",
        transactionId : data[0],
        timestamp : data[2]
    };
}
%}


ErrorResponse -> String  __  DateTime 

{% ( data ) => {
    return {
        $class: "org.accordproject.common.ErrorResponse",
        transactionId : data[0],
        timestamp : data[2]
    };
}
%}


Payload -> ContractModel  __  Request  __  ContractState 

{% ( data ) => {
    return {
        $class: "org.accordproject.common.Payload",
        contract : data[0],
        request : data[2],
        state : data[4]
    };
}
%}


Success -> Response  __  ContractState  __  Event:+ 

{% ( data ) => {
    return {
        $class: "org.accordproject.common.Success",
        response : data[0],
        state : data[2],
        emit : data[4]
    };
}
%}


Failure -> ErrorResponse 

{% ( data ) => {
    return {
        $class: "org.accordproject.common.Failure",
        error : data[0]
    };
}
%}


TemporalUnit -> "SECOND" {% id %} | "MINUTE" {% id %} | "HOUR" {% id %} | "DAY" {% id %} | "WEEK" {% id %} | "YEAR" {% id %} 


Duration -> Long  __  TemporalUnit 

{% ( data ) => {
    return {
        $class: "org.accordproject.base.Duration",
        amount : data[0],
        unit : data[2]
    };
}
%}


PaymentRequest -> Double  __  Double  __  DateTime:?  __  String  __  DateTime 

{% ( data ) => {
    return {
        $class: "org.accordproject.ippayment.PaymentRequest",
        netSaleRevenue : data[0],
        sublicensingRevenue : data[2],
        permissionGrantedBy : data[4],
        transactionId : data[6],
        timestamp : data[8]
    };
}
%}


PayOut -> Double  __  String  __  String  __  DateTime 

{% ( data ) => {
    return {
        $class: "org.accordproject.ippayment.PayOut",
        totalAmount : data[0],
        dueBy : data[2],
        transactionId : data[4],
        timestamp : data[6]
    };
}
%}



# Basic types
NUMBER -> [0-9] 
{% (d) => {return parseInt(d[0]);}%}

DOUBLE_NUMBER -> NUMBER NUMBER
{% (d) => {return '' + d[0] + d[1]}%}

MONTH -> DOUBLE_NUMBER
DAY -> DOUBLE_NUMBER
YEAR -> DOUBLE_NUMBER DOUBLE_NUMBER
{% (d) => {return '' + d[0] + d[1]}%}

DATE -> MONTH "/" DAY "/" YEAR
{% (d) => {return '' + d[4] + '-' + d[0] + '-' + d[2]}%}

Word -> [\S]:*
{% (d) => {return d[0].join('');}%}

BRACKET_PHRASE -> "[" Word (__ Word):* "]" {% ((d) => {return d[1] + ' ' + flatten(d[2]).join(" ");}) %}

String -> dqstring {% id %}
Double -> decimal {% id %}
Integer -> int {% id %}
Long -> int {% id %}
Boolean -> "true" {% id %} | "false" {% id %}
DateTime -> DATE  {% id %}